#!/usr/bin/perl
use CGI;
use GD;
use Digest::MD5;

package TGimpy;
;########################################################################
;#	CAPTCHA Tiny-Gimpy
;#
;#			Programmed by Piroli YUKARINOMIYA <piroli@magicvox.net>
;########################################################################
;# '05/06/01	1.00	ō쐬
;########################################################################

;### ̃t@CύXꍇ * K * CĂ
$szMyName = 'tgimpy.cgi';

;### ݒt@Cւ̃fBNgpX
sub GetCfgPath { return '/home/yourname/data/tgimpy'; }



;########################################################################
;# CGI ̃CGg
&CGIMain () if ($ENV{'SCRIPT_NAME'} =~ m/$szMyName$/);
sub CGIMain
{
	my $q = CGI->new;
	my $txt = $q->param ('excerpt');

	my $cfg = $q->param ('cfg');
	$cfg = undef if (! $cfg);
	my $key = $q->param ('key');
	$key = rand () if (! $key);

	OpenConfigFile ($cfg);
	my $ans = GetAnswer ($key);
	CreateImage ($ans);

	exit;
}

;########################################################################
;# ݒt@Cǂݍ
sub OpenConfigFile
{
	my $cfg = shift;

	;# Kl`邪A̒lł̎sʂɈӖ͂Ȃ
	$szCryptKey = '';
	$nFigure    = 9;

	;# spX
	return (0) if (! $cfg);
	return (0) if ($cfg =~ m/[^\w]/);
	my $cfg_file = GetCfgPath (). "/${cfg}.cfg";

	;# ݒlC|[g
	eval {
		require $cfg_file;
	};
	return (0) if ($@);

	;# l`FbN
	$nFigure = int ($nFigure + 0.5);
	$nFigure = 1 if ($nFigure < 1);
	$nFigure = 9 if (9 < $nFigure);

	return (1);
}

;########################################################################
;# L[ɑΉ߂
sub GetAnswer
{
	my $key = shift;

	my $md5 = Digest::MD5->new ();
	$md5->add ($key);
	$md5->add ($szCryptKey);

	my $s = 0;	
	my $mod_num = (10 ** $nFigure);
	foreach my $i (split ("", $md5->digest)) {
		$s = ($s * 256 + ord ($i)) % $mod_num;
	}

	return (substr (sprintf ("%09d", $s), 9 - $nFigure));
}

;########################################################################
;# 摜𐶐
sub CreateImage
{
	my $ans = shift;

	;# Kl
	$nSizeX = 88 if (! $nSizeX || $nSizeX < 0);
	$nSizeY = 15 if (! $nSizeY || $nSizeY < 0);

	my $img = new GD::Image ($nSizeX, $nSizeY);
	if ($img == undef)
	{
		print "Content-type: text/plain\n\n";
		print "fail to create GD::Image object\n";
		return (0);
	}

	;# ̐Fm
	my $colBG = GetColor ($img, "ffffff");
	my $colFG = GetColor ($img, "000000");

	;# wi쐬
	$img->filledRectangle (0,0, $nSizeX-1,$nSizeY-1, $colBG);
	$img->rectangle (0,0, $nSizeX-1,$nSizeY-1, $colFG);

	;# `
	$fx = ($nSizeX - 9 * $nFigure) / 2;
	$fy = ($nSizeY - 15) / 2;
	$img->string (GD::Font->Giant, $fx,$fy    , $ans, $colFG);
	$img->string (GD::Font->Giant, $fx,$fy - 1, $ans, $colFG);

	;# oCiEXg[֏ނƂmɂ
	binmode STDOUT;
	;# C[WPNGɕϊAWo͂ɏo
	print "Content-type: image/png\n\n";
	print $img->png;
}

;########################################################################
;# 낢돬
sub GetColor
{
	my $img = shift;
	my $rgb = shift;

	;# RRGGBB
	($r, $g, $b) = $rgb =~ /#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})/;
	return ($img->colorResolve (hex ($r), hex ($g), hex ($b))) if ($r && $g && $b);
	;# RGB
	($r, $g, $b) = $rgb =~ /#?([0-9a-fA-F])([0-9a-fA-F])([0-9a-fA-F])/;
	return ($img->colorResolve (hex ($r.$r), hex ($g.$g), hex ($b.$b))) if ($r && $g && $b);

	return ($img->colorResolve (0, 0, 0));
}



;########################################################################
;# 킹
sub CheckAnswer
{
	my $cfg = shift;
	my $key = shift;
	my $ans = shift;

	return (0) if (! OpenConfigFile ($cfg));
	return (0) if (GetAnswer ($key) ne $ans);

	return (1);
}

1;
